/* Terminal.c generated by valac 0.56.14, the Vala compiler
 * generated from Terminal.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-3.0-or-later
 * SPDX-FileCopyrightText: 2022 elementary, Inc. (https://elementary.io)
 *                         2011-2013 Mario Guerriero <mario@elementaryos.org>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <vte/vte.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>

#define CODE_TERMINAL_MAX_SCALE 5.0
#define CODE_TERMINAL_MIN_SCALE 0.2
#define CODE_TERMINAL_LEGACY_SETTINGS_SCHEMA "org.pantheon.terminal.settings"
#define CODE_TERMINAL_SETTINGS_SCHEMA "io.elementary.terminal.settings"
#define SCRATCH_MAIN_WINDOW_ACTION_GROUP "win"
#define SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_GROUP "."
#define SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL "action-toggle-terminal"
#define CONSTANTS_PROJECT_NAME "io.elementary.code"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CODE_TYPE_TERMINAL (code_terminal_get_type ())
#define CODE_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CODE_TYPE_TERMINAL, CodeTerminal))
#define CODE_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CODE_TYPE_TERMINAL, CodeTerminalClass))
#define CODE_IS_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CODE_TYPE_TERMINAL))
#define CODE_IS_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CODE_TYPE_TERMINAL))
#define CODE_TERMINAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CODE_TYPE_TERMINAL, CodeTerminalClass))

typedef struct _CodeTerminal CodeTerminal;
typedef struct _CodeTerminalClass CodeTerminalClass;
typedef struct _CodeTerminalPrivate CodeTerminalPrivate;
enum  {
	CODE_TERMINAL_0_PROPERTY,
	CODE_TERMINAL_TERMINAL_PROPERTY,
	CODE_TERMINAL_NUM_PROPERTIES
};
static GParamSpec* code_terminal_properties[CODE_TERMINAL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
typedef struct _Block40Data Block40Data;
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))

struct _CodeTerminal {
	GtkBox parent_instance;
	CodeTerminalPrivate * priv;
};

struct _CodeTerminalClass {
	GtkBoxClass parent_class;
};

struct _CodeTerminalPrivate {
	GPid child_pid;
	VteTerminal* _terminal;
};

struct _Block40Data {
	int _ref_count_;
	CodeTerminal* self;
	GtkMenu* menu;
	GSettings* settings;
};

static gint CodeTerminal_private_offset;
static gpointer code_terminal_parent_class = NULL;

VALA_EXTERN GType code_terminal_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CodeTerminal, g_object_unref)
static void code_terminal_spawn_shell (CodeTerminal* self,
                                const gchar* dir);
VALA_EXTERN VteTerminal* code_terminal_get_terminal (CodeTerminal* self);
VALA_EXTERN void code_terminal_change_location (CodeTerminal* self,
                                    const gchar* dir);
static gchar* code_terminal_get_shell_location (CodeTerminal* self);
static void code_terminal_update_terminal_settings (CodeTerminal* self,
                                             const gchar* settings_schema);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
VALA_EXTERN void code_terminal_increment_size (CodeTerminal* self);
VALA_EXTERN void code_terminal_decrement_size (CodeTerminal* self);
VALA_EXTERN void code_terminal_set_default_font_size (CodeTerminal* self);
VALA_EXTERN CodeTerminal* code_terminal_new (void);
VALA_EXTERN CodeTerminal* code_terminal_construct (GType object_type);
static void code_terminal_set_terminal (CodeTerminal* self,
                                 VteTerminal* value);
static GObject * code_terminal_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static Block40Data* block40_data_ref (Block40Data* _data40_);
static void block40_data_unref (void * _userdata_);
static void _code_terminal___lambda123_ (CodeTerminal* self);
static void __code_terminal___lambda123__vte_terminal_child_exited (VteTerminal* _sender,
                                                             gint status,
                                                             gpointer self);
static void _code_terminal___lambda124_ (CodeTerminal* self);
static void __code_terminal___lambda124__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static void _code_terminal___lambda125_ (CodeTerminal* self);
static void __code_terminal___lambda125__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static gboolean _code_terminal___lambda126_ (Block40Data* _data40_,
                                      GdkEventButton* event);
static gboolean __code_terminal___lambda126__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                     GdkEventButton* event,
                                                                     gpointer self);
static void _code_terminal___lambda127_ (Block40Data* _data40_);
static void __code_terminal___lambda127__gtk_widget_destroy (GtkWidget* _sender,
                                                      gpointer self);
static void code_terminal_finalize (GObject * obj);
static GType code_terminal_get_type_once (void);
static void _vala_code_terminal_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_code_terminal_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
code_terminal_get_instance_private (CodeTerminal* self)
{
	return G_STRUCT_MEMBER_P (self, CodeTerminal_private_offset);
}

static void
code_terminal_spawn_shell (CodeTerminal* self,
                           const gchar* dir)
{
	GError* _inner_error0_ = NULL;
#line 77 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Widgets/Terminal.vala"
	g_return_if_fail (dir != NULL);
#line 172 "Terminal.c"
	{
		VteTerminal* _tmp0_;
		gchar* _tmp1_;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _tmp3__length1;
		GPid _tmp4_ = 0;
#line 79 "../src/Widgets/Terminal.vala"
		_tmp0_ = self->priv->_terminal;
#line 79 "../src/Widgets/Terminal.vala"
		_tmp1_ = vte_get_user_shell ();
#line 79 "../src/Widgets/Terminal.vala"
		_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 79 "../src/Widgets/Terminal.vala"
		_tmp2_[0] = _tmp1_;
#line 79 "../src/Widgets/Terminal.vala"
		_tmp3_ = _tmp2_;
#line 79 "../src/Widgets/Terminal.vala"
		_tmp3__length1 = 1;
#line 79 "../src/Widgets/Terminal.vala"
		vte_terminal_spawn_sync (_tmp0_, VTE_PTY_DEFAULT, dir, _tmp3_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp4_, NULL, &_inner_error0_);
#line 79 "../src/Widgets/Terminal.vala"
		self->priv->child_pid = _tmp4_;
#line 79 "../src/Widgets/Terminal.vala"
		_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
#line 79 "../src/Widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 200 "Terminal.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 78 "../src/Widgets/Terminal.vala"
		e = _inner_error0_;
#line 78 "../src/Widgets/Terminal.vala"
		_inner_error0_ = NULL;
#line 90 "../src/Widgets/Terminal.vala"
		_tmp5_ = e;
#line 90 "../src/Widgets/Terminal.vala"
		_tmp6_ = _tmp5_->message;
#line 90 "../src/Widgets/Terminal.vala"
		g_warning ("Terminal.vala:90: %s", _tmp6_);
#line 78 "../src/Widgets/Terminal.vala"
		_g_error_free0 (e);
#line 222 "Terminal.c"
	}
	__finally0:
#line 78 "../src/Widgets/Terminal.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 78 "../src/Widgets/Terminal.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 78 "../src/Widgets/Terminal.vala"
		g_clear_error (&_inner_error0_);
#line 78 "../src/Widgets/Terminal.vala"
		return;
#line 233 "Terminal.c"
	}
}

void
code_terminal_change_location (CodeTerminal* self,
                               const gchar* dir)
{
	VteTerminal* _tmp0_;
#line 94 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 94 "../src/Widgets/Terminal.vala"
	g_return_if_fail (dir != NULL);
#line 95 "../src/Widgets/Terminal.vala"
	kill ((pid_t) self->priv->child_pid, (gint) SIGTERM);
#line 96 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 96 "../src/Widgets/Terminal.vala"
	vte_terminal_reset (_tmp0_, TRUE, TRUE);
#line 97 "../src/Widgets/Terminal.vala"
	code_terminal_spawn_shell (self, dir);
#line 254 "Terminal.c"
}

static gchar*
code_terminal_get_shell_location (CodeTerminal* self)
{
	gint pid = 0;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 100 "../src/Widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../src/Widgets/Terminal.vala"
	pid = (gint) ((GPid) self->priv->child_pid);
#line 267 "Terminal.c"
	{
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 103 "../src/Widgets/Terminal.vala"
		_tmp1_ = g_strdup_printf ("/proc/%d/cwd", pid);
#line 103 "../src/Widgets/Terminal.vala"
		_tmp2_ = _tmp1_;
#line 103 "../src/Widgets/Terminal.vala"
		_tmp3_ = g_file_read_link (_tmp2_, &_inner_error0_);
#line 103 "../src/Widgets/Terminal.vala"
		_tmp4_ = _tmp3_;
#line 103 "../src/Widgets/Terminal.vala"
		_g_free0 (_tmp2_);
#line 103 "../src/Widgets/Terminal.vala"
		_tmp0_ = _tmp4_;
#line 103 "../src/Widgets/Terminal.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 103 "../src/Widgets/Terminal.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 291 "Terminal.c"
				goto __catch0_g_file_error;
			}
#line 103 "../src/Widgets/Terminal.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "../src/Widgets/Terminal.vala"
			g_clear_error (&_inner_error0_);
#line 103 "../src/Widgets/Terminal.vala"
			return NULL;
#line 300 "Terminal.c"
		}
#line 103 "../src/Widgets/Terminal.vala"
		_tmp5_ = _tmp0_;
#line 103 "../src/Widgets/Terminal.vala"
		_tmp0_ = NULL;
#line 103 "../src/Widgets/Terminal.vala"
		result = _tmp5_;
#line 103 "../src/Widgets/Terminal.vala"
		_g_free0 (_tmp0_);
#line 103 "../src/Widgets/Terminal.vala"
		return result;
#line 312 "Terminal.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 102 "../src/Widgets/Terminal.vala"
		_error_ = _inner_error0_;
#line 102 "../src/Widgets/Terminal.vala"
		_inner_error0_ = NULL;
#line 105 "../src/Widgets/Terminal.vala"
		_tmp6_ = _error_;
#line 105 "../src/Widgets/Terminal.vala"
		_tmp7_ = _tmp6_->message;
#line 105 "../src/Widgets/Terminal.vala"
		g_warning ("Terminal.vala:105: An error occurred while fetching the current dir of" \
" shell: %s", _tmp7_);
#line 106 "../src/Widgets/Terminal.vala"
		_tmp8_ = g_strdup ("");
#line 106 "../src/Widgets/Terminal.vala"
		result = _tmp8_;
#line 106 "../src/Widgets/Terminal.vala"
		_g_error_free0 (_error_);
#line 106 "../src/Widgets/Terminal.vala"
		return result;
#line 339 "Terminal.c"
	}
	__finally0:
#line 102 "../src/Widgets/Terminal.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 102 "../src/Widgets/Terminal.vala"
	g_clear_error (&_inner_error0_);
#line 102 "../src/Widgets/Terminal.vala"
	return NULL;
#line 348 "Terminal.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 365 "Terminal.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 110 "../src/Widgets/Terminal.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 373 "Terminal.c"
}

static void
code_terminal_update_terminal_settings (CodeTerminal* self,
                                        const gchar* settings_schema)
{
	GSettings* pantheon_terminal_settings = NULL;
	GSettings* _tmp0_;
	gchar* font_name = NULL;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	PangoFontDescription* fd = NULL;
	const gchar* _tmp7_;
	PangoFontDescription* _tmp8_;
	VteTerminal* _tmp9_;
	PangoFontDescription* _tmp10_;
	gboolean audible_bell_setting = FALSE;
	GSettings* _tmp11_;
	VteTerminal* _tmp12_;
	gchar* cursor_shape_setting = NULL;
	GSettings* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GQuark _tmp18_ = 0U;
#line 127 "../src/Widgets/Terminal.vala"
	static GQuark _tmp17_label0 = 0;
#line 127 "../src/Widgets/Terminal.vala"
	static GQuark _tmp17_label1 = 0;
#line 127 "../src/Widgets/Terminal.vala"
	static GQuark _tmp17_label2 = 0;
#line 406 "Terminal.c"
	gchar* background_setting = NULL;
	GSettings* _tmp22_;
	gchar* _tmp23_;
	GdkRGBA background_color = {0};
	const gchar* _tmp24_;
	gchar* foreground_setting = NULL;
	GSettings* _tmp25_;
	gchar* _tmp26_;
	GdkRGBA foreground_color = {0};
	const gchar* _tmp27_;
	gchar* palette_setting = NULL;
	GSettings* _tmp28_;
	gchar* _tmp29_;
	gchar** hex_palette = NULL;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar** _tmp46_;
	gint hex_palette_length1;
	gint _hex_palette_size_;
	gchar* current_string = NULL;
	gchar* _tmp47_;
	gint current_color = 0;
	GdkRGBA* palette = NULL;
	GdkRGBA* _tmp64_;
	gint palette_length1;
	gint _palette_size_;
	VteTerminal* _tmp72_;
	GdkRGBA _tmp73_;
	GdkRGBA _tmp74_;
	GdkRGBA* _tmp75_;
	gint _tmp75__length1;
#line 110 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/Widgets/Terminal.vala"
	g_return_if_fail (settings_schema != NULL);
#line 111 "../src/Widgets/Terminal.vala"
	_tmp0_ = g_settings_new (settings_schema);
#line 111 "../src/Widgets/Terminal.vala"
	pantheon_terminal_settings = _tmp0_;
#line 113 "../src/Widgets/Terminal.vala"
	_tmp1_ = pantheon_terminal_settings;
#line 113 "../src/Widgets/Terminal.vala"
	_tmp2_ = g_settings_get_string (_tmp1_, "font");
#line 113 "../src/Widgets/Terminal.vala"
	font_name = _tmp2_;
#line 114 "../src/Widgets/Terminal.vala"
	_tmp3_ = font_name;
#line 114 "../src/Widgets/Terminal.vala"
	if (g_strcmp0 (_tmp3_, "") == 0) {
#line 470 "Terminal.c"
		GSettings* system_settings = NULL;
		GSettings* _tmp4_;
		GSettings* _tmp5_;
		gchar* _tmp6_;
#line 115 "../src/Widgets/Terminal.vala"
		_tmp4_ = g_settings_new ("org.gnome.desktop.interface");
#line 115 "../src/Widgets/Terminal.vala"
		system_settings = _tmp4_;
#line 116 "../src/Widgets/Terminal.vala"
		_tmp5_ = system_settings;
#line 116 "../src/Widgets/Terminal.vala"
		_tmp6_ = g_settings_get_string (_tmp5_, "monospace-font-name");
#line 116 "../src/Widgets/Terminal.vala"
		_g_free0 (font_name);
#line 116 "../src/Widgets/Terminal.vala"
		font_name = _tmp6_;
#line 114 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (system_settings);
#line 489 "Terminal.c"
	}
#line 119 "../src/Widgets/Terminal.vala"
	_tmp7_ = font_name;
#line 119 "../src/Widgets/Terminal.vala"
	_tmp8_ = pango_font_description_from_string (_tmp7_);
#line 119 "../src/Widgets/Terminal.vala"
	fd = _tmp8_;
#line 120 "../src/Widgets/Terminal.vala"
	_tmp9_ = self->priv->_terminal;
#line 120 "../src/Widgets/Terminal.vala"
	_tmp10_ = fd;
#line 120 "../src/Widgets/Terminal.vala"
	vte_terminal_set_font (_tmp9_, _tmp10_);
#line 122 "../src/Widgets/Terminal.vala"
	_tmp11_ = pantheon_terminal_settings;
#line 122 "../src/Widgets/Terminal.vala"
	audible_bell_setting = g_settings_get_boolean (_tmp11_, "audible-bell");
#line 123 "../src/Widgets/Terminal.vala"
	_tmp12_ = self->priv->_terminal;
#line 123 "../src/Widgets/Terminal.vala"
	vte_terminal_set_audible_bell (_tmp12_, audible_bell_setting);
#line 125 "../src/Widgets/Terminal.vala"
	_tmp13_ = pantheon_terminal_settings;
#line 125 "../src/Widgets/Terminal.vala"
	_tmp14_ = g_settings_get_string (_tmp13_, "cursor-shape");
#line 125 "../src/Widgets/Terminal.vala"
	cursor_shape_setting = _tmp14_;
#line 127 "../src/Widgets/Terminal.vala"
	_tmp15_ = cursor_shape_setting;
#line 127 "../src/Widgets/Terminal.vala"
	_tmp16_ = _tmp15_;
#line 127 "../src/Widgets/Terminal.vala"
	_tmp18_ = (NULL == _tmp16_) ? 0 : g_quark_from_string (_tmp16_);
#line 127 "../src/Widgets/Terminal.vala"
	if (_tmp18_ == ((0 != _tmp17_label0) ? _tmp17_label0 : (_tmp17_label0 = g_quark_from_static_string ("Block")))) {
#line 127 "../src/Widgets/Terminal.vala"
		switch (0) {
#line 527 "Terminal.c"
			default:
			{
				VteTerminal* _tmp19_;
#line 129 "../src/Widgets/Terminal.vala"
				_tmp19_ = self->priv->_terminal;
#line 129 "../src/Widgets/Terminal.vala"
				vte_terminal_set_cursor_shape (_tmp19_, VTE_CURSOR_SHAPE_BLOCK);
#line 130 "../src/Widgets/Terminal.vala"
				break;
#line 537 "Terminal.c"
			}
		}
	} else if (_tmp18_ == ((0 != _tmp17_label1) ? _tmp17_label1 : (_tmp17_label1 = g_quark_from_static_string ("I-Beam")))) {
#line 127 "../src/Widgets/Terminal.vala"
		switch (0) {
#line 543 "Terminal.c"
			default:
			{
				VteTerminal* _tmp20_;
#line 132 "../src/Widgets/Terminal.vala"
				_tmp20_ = self->priv->_terminal;
#line 132 "../src/Widgets/Terminal.vala"
				vte_terminal_set_cursor_shape (_tmp20_, VTE_CURSOR_SHAPE_IBEAM);
#line 133 "../src/Widgets/Terminal.vala"
				break;
#line 553 "Terminal.c"
			}
		}
	} else if (_tmp18_ == ((0 != _tmp17_label2) ? _tmp17_label2 : (_tmp17_label2 = g_quark_from_static_string ("Underline")))) {
#line 127 "../src/Widgets/Terminal.vala"
		switch (0) {
#line 559 "Terminal.c"
			default:
			{
				VteTerminal* _tmp21_;
#line 135 "../src/Widgets/Terminal.vala"
				_tmp21_ = self->priv->_terminal;
#line 135 "../src/Widgets/Terminal.vala"
				vte_terminal_set_cursor_shape (_tmp21_, VTE_CURSOR_SHAPE_UNDERLINE);
#line 136 "../src/Widgets/Terminal.vala"
				break;
#line 569 "Terminal.c"
			}
		}
	}
#line 139 "../src/Widgets/Terminal.vala"
	_tmp22_ = pantheon_terminal_settings;
#line 139 "../src/Widgets/Terminal.vala"
	_tmp23_ = g_settings_get_string (_tmp22_, "background");
#line 139 "../src/Widgets/Terminal.vala"
	background_setting = _tmp23_;
#line 140 "../src/Widgets/Terminal.vala"
	memset (&background_color, 0, sizeof (GdkRGBA));
#line 141 "../src/Widgets/Terminal.vala"
	_tmp24_ = background_setting;
#line 141 "../src/Widgets/Terminal.vala"
	gdk_rgba_parse (&background_color, _tmp24_);
#line 143 "../src/Widgets/Terminal.vala"
	_tmp25_ = pantheon_terminal_settings;
#line 143 "../src/Widgets/Terminal.vala"
	_tmp26_ = g_settings_get_string (_tmp25_, "foreground");
#line 143 "../src/Widgets/Terminal.vala"
	foreground_setting = _tmp26_;
#line 144 "../src/Widgets/Terminal.vala"
	memset (&foreground_color, 0, sizeof (GdkRGBA));
#line 145 "../src/Widgets/Terminal.vala"
	_tmp27_ = foreground_setting;
#line 145 "../src/Widgets/Terminal.vala"
	gdk_rgba_parse (&foreground_color, _tmp27_);
#line 147 "../src/Widgets/Terminal.vala"
	_tmp28_ = pantheon_terminal_settings;
#line 147 "../src/Widgets/Terminal.vala"
	_tmp29_ = g_settings_get_string (_tmp28_, "palette");
#line 147 "../src/Widgets/Terminal.vala"
	palette_setting = _tmp29_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp30_ = g_strdup ("#000000");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp31_ = g_strdup ("#FF6C60");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp32_ = g_strdup ("#A8FF60");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp33_ = g_strdup ("#FFFFCC");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp34_ = g_strdup ("#96CBFE");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp35_ = g_strdup ("#FF73FE");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp36_ = g_strdup ("#C6C5FE");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp37_ = g_strdup ("#EEEEEE");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp38_ = g_strdup ("#000000");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp39_ = g_strdup ("#FF6C60");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp40_ = g_strdup ("#A8FF60");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp41_ = g_strdup ("#FFFFB6");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp42_ = g_strdup ("#96CBFE");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp43_ = g_strdup ("#FF73FE");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp44_ = g_strdup ("#C6C5FE");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp45_ = g_strdup ("#EEEEEE");
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_ = g_new0 (gchar*, 16 + 1);
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[0] = _tmp30_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[1] = _tmp31_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[2] = _tmp32_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[3] = _tmp33_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[4] = _tmp34_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[5] = _tmp35_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[6] = _tmp36_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[7] = _tmp37_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[8] = _tmp38_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[9] = _tmp39_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[10] = _tmp40_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[11] = _tmp41_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[12] = _tmp42_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[13] = _tmp43_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[14] = _tmp44_;
#line 149 "../src/Widgets/Terminal.vala"
	_tmp46_[15] = _tmp45_;
#line 149 "../src/Widgets/Terminal.vala"
	hex_palette = _tmp46_;
#line 149 "../src/Widgets/Terminal.vala"
	hex_palette_length1 = 16;
#line 149 "../src/Widgets/Terminal.vala"
	_hex_palette_size_ = hex_palette_length1;
#line 154 "../src/Widgets/Terminal.vala"
	_tmp47_ = g_strdup ("");
#line 154 "../src/Widgets/Terminal.vala"
	current_string = _tmp47_;
#line 155 "../src/Widgets/Terminal.vala"
	current_color = 0;
#line 681 "Terminal.c"
	{
		gint i = 0;
#line 156 "../src/Widgets/Terminal.vala"
		i = 0;
#line 686 "Terminal.c"
		{
			gboolean _tmp48_ = FALSE;
#line 156 "../src/Widgets/Terminal.vala"
			_tmp48_ = TRUE;
#line 156 "../src/Widgets/Terminal.vala"
			while (TRUE) {
#line 693 "Terminal.c"
				const gchar* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
				const gchar* _tmp53_;
#line 156 "../src/Widgets/Terminal.vala"
				if (!_tmp48_) {
#line 700 "Terminal.c"
					gint _tmp49_;
#line 156 "../src/Widgets/Terminal.vala"
					_tmp49_ = i;
#line 156 "../src/Widgets/Terminal.vala"
					i = _tmp49_ + 1;
#line 706 "Terminal.c"
				}
#line 156 "../src/Widgets/Terminal.vala"
				_tmp48_ = FALSE;
#line 156 "../src/Widgets/Terminal.vala"
				_tmp50_ = palette_setting;
#line 156 "../src/Widgets/Terminal.vala"
				_tmp51_ = strlen (_tmp50_);
#line 156 "../src/Widgets/Terminal.vala"
				_tmp52_ = _tmp51_;
#line 156 "../src/Widgets/Terminal.vala"
				if (!(i < _tmp52_)) {
#line 156 "../src/Widgets/Terminal.vala"
					break;
#line 720 "Terminal.c"
				}
#line 157 "../src/Widgets/Terminal.vala"
				_tmp53_ = palette_setting;
#line 157 "../src/Widgets/Terminal.vala"
				if (string_get (_tmp53_, (glong) i) == ':') {
#line 726 "Terminal.c"
					gchar** _tmp54_;
					gint _tmp54__length1;
					const gchar* _tmp55_;
					gchar* _tmp56_;
					gchar* _tmp57_;
					gint _tmp58_;
#line 158 "../src/Widgets/Terminal.vala"
					_tmp54_ = hex_palette;
#line 158 "../src/Widgets/Terminal.vala"
					_tmp54__length1 = hex_palette_length1;
#line 158 "../src/Widgets/Terminal.vala"
					_tmp55_ = current_string;
#line 158 "../src/Widgets/Terminal.vala"
					_tmp56_ = g_strdup (_tmp55_);
#line 158 "../src/Widgets/Terminal.vala"
					_g_free0 (_tmp54_[current_color]);
#line 158 "../src/Widgets/Terminal.vala"
					_tmp54_[current_color] = _tmp56_;
#line 159 "../src/Widgets/Terminal.vala"
					_tmp57_ = g_strdup ("");
#line 159 "../src/Widgets/Terminal.vala"
					_g_free0 (current_string);
#line 159 "../src/Widgets/Terminal.vala"
					current_string = _tmp57_;
#line 160 "../src/Widgets/Terminal.vala"
					_tmp58_ = current_color;
#line 160 "../src/Widgets/Terminal.vala"
					current_color = _tmp58_ + 1;
#line 755 "Terminal.c"
				} else {
					const gchar* _tmp59_;
					const gchar* _tmp60_;
					gchar* _tmp61_;
					gchar* _tmp62_;
					gchar* _tmp63_;
#line 162 "../src/Widgets/Terminal.vala"
					_tmp59_ = current_string;
#line 162 "../src/Widgets/Terminal.vala"
					_tmp60_ = palette_setting;
#line 162 "../src/Widgets/Terminal.vala"
					_tmp61_ = g_strdup_printf ("%c", string_get (_tmp60_, (glong) i));
#line 162 "../src/Widgets/Terminal.vala"
					_tmp62_ = _tmp61_;
#line 162 "../src/Widgets/Terminal.vala"
					_tmp63_ = g_strconcat (_tmp59_, _tmp62_, NULL);
#line 162 "../src/Widgets/Terminal.vala"
					_g_free0 (current_string);
#line 162 "../src/Widgets/Terminal.vala"
					current_string = _tmp63_;
#line 162 "../src/Widgets/Terminal.vala"
					_g_free0 (_tmp62_);
#line 778 "Terminal.c"
				}
			}
		}
	}
#line 166 "../src/Widgets/Terminal.vala"
	_tmp64_ = g_new0 (GdkRGBA, 16);
#line 166 "../src/Widgets/Terminal.vala"
	palette = _tmp64_;
#line 166 "../src/Widgets/Terminal.vala"
	palette_length1 = 16;
#line 166 "../src/Widgets/Terminal.vala"
	_palette_size_ = palette_length1;
#line 791 "Terminal.c"
	{
		gint i = 0;
#line 168 "../src/Widgets/Terminal.vala"
		i = 0;
#line 796 "Terminal.c"
		{
			gboolean _tmp65_ = FALSE;
#line 168 "../src/Widgets/Terminal.vala"
			_tmp65_ = TRUE;
#line 168 "../src/Widgets/Terminal.vala"
			while (TRUE) {
#line 803 "Terminal.c"
				gchar** _tmp67_;
				gint _tmp67__length1;
				GdkRGBA new_color = {0};
				gchar** _tmp68_;
				gint _tmp68__length1;
				const gchar* _tmp69_;
				GdkRGBA* _tmp70_;
				gint _tmp70__length1;
				GdkRGBA _tmp71_;
#line 168 "../src/Widgets/Terminal.vala"
				if (!_tmp65_) {
#line 815 "Terminal.c"
					gint _tmp66_;
#line 168 "../src/Widgets/Terminal.vala"
					_tmp66_ = i;
#line 168 "../src/Widgets/Terminal.vala"
					i = _tmp66_ + 1;
#line 821 "Terminal.c"
				}
#line 168 "../src/Widgets/Terminal.vala"
				_tmp65_ = FALSE;
#line 168 "../src/Widgets/Terminal.vala"
				_tmp67_ = hex_palette;
#line 168 "../src/Widgets/Terminal.vala"
				_tmp67__length1 = hex_palette_length1;
#line 168 "../src/Widgets/Terminal.vala"
				if (!(i < _tmp67__length1)) {
#line 168 "../src/Widgets/Terminal.vala"
					break;
#line 833 "Terminal.c"
				}
#line 169 "../src/Widgets/Terminal.vala"
				memset (&new_color, 0, sizeof (GdkRGBA));
#line 170 "../src/Widgets/Terminal.vala"
				_tmp68_ = hex_palette;
#line 170 "../src/Widgets/Terminal.vala"
				_tmp68__length1 = hex_palette_length1;
#line 170 "../src/Widgets/Terminal.vala"
				_tmp69_ = _tmp68_[i];
#line 170 "../src/Widgets/Terminal.vala"
				gdk_rgba_parse (&new_color, _tmp69_);
#line 171 "../src/Widgets/Terminal.vala"
				_tmp70_ = palette;
#line 171 "../src/Widgets/Terminal.vala"
				_tmp70__length1 = palette_length1;
#line 171 "../src/Widgets/Terminal.vala"
				_tmp71_ = new_color;
#line 171 "../src/Widgets/Terminal.vala"
				_tmp70_[i] = _tmp71_;
#line 853 "Terminal.c"
			}
		}
	}
#line 174 "../src/Widgets/Terminal.vala"
	_tmp72_ = self->priv->_terminal;
#line 174 "../src/Widgets/Terminal.vala"
	_tmp73_ = foreground_color;
#line 174 "../src/Widgets/Terminal.vala"
	_tmp74_ = background_color;
#line 174 "../src/Widgets/Terminal.vala"
	_tmp75_ = palette;
#line 174 "../src/Widgets/Terminal.vala"
	_tmp75__length1 = palette_length1;
#line 174 "../src/Widgets/Terminal.vala"
	vte_terminal_set_colors (_tmp72_, &_tmp73_, &_tmp74_, _tmp75_, (gsize) _tmp75__length1);
#line 110 "../src/Widgets/Terminal.vala"
	palette = (g_free (palette), NULL);
#line 110 "../src/Widgets/Terminal.vala"
	_g_free0 (current_string);
#line 110 "../src/Widgets/Terminal.vala"
	hex_palette = (_vala_array_free (hex_palette, hex_palette_length1, (GDestroyNotify) g_free), NULL);
#line 110 "../src/Widgets/Terminal.vala"
	_g_free0 (palette_setting);
#line 110 "../src/Widgets/Terminal.vala"
	_g_free0 (foreground_setting);
#line 110 "../src/Widgets/Terminal.vala"
	_g_free0 (background_setting);
#line 110 "../src/Widgets/Terminal.vala"
	_g_free0 (cursor_shape_setting);
#line 110 "../src/Widgets/Terminal.vala"
	__vala_PangoFontDescription_free0 (fd);
#line 110 "../src/Widgets/Terminal.vala"
	_g_free0 (font_name);
#line 110 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (pantheon_terminal_settings);
#line 889 "Terminal.c"
}

void
code_terminal_increment_size (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
	VteTerminal* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 177 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 178 "../src/Widgets/Terminal.vala"
	_tmp1_ = self->priv->_terminal;
#line 178 "../src/Widgets/Terminal.vala"
	_tmp2_ = vte_terminal_get_font_scale (_tmp1_);
#line 178 "../src/Widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 178 "../src/Widgets/Terminal.vala"
	vte_terminal_set_font_scale (_tmp0_, CLAMP (_tmp3_ + 0.1, CODE_TERMINAL_MIN_SCALE, CODE_TERMINAL_MAX_SCALE));
#line 911 "Terminal.c"
}

void
code_terminal_decrement_size (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
	VteTerminal* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 181 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 182 "../src/Widgets/Terminal.vala"
	_tmp1_ = self->priv->_terminal;
#line 182 "../src/Widgets/Terminal.vala"
	_tmp2_ = vte_terminal_get_font_scale (_tmp1_);
#line 182 "../src/Widgets/Terminal.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/Widgets/Terminal.vala"
	vte_terminal_set_font_scale (_tmp0_, CLAMP (_tmp3_ - 0.1, CODE_TERMINAL_MIN_SCALE, CODE_TERMINAL_MAX_SCALE));
#line 933 "Terminal.c"
}

void
code_terminal_set_default_font_size (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
#line 185 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 186 "../src/Widgets/Terminal.vala"
	vte_terminal_set_font_scale (_tmp0_, 1.0);
#line 946 "Terminal.c"
}

CodeTerminal*
code_terminal_construct (GType object_type)
{
	CodeTerminal * self = NULL;
#line 7 "../src/Widgets/Terminal.vala"
	self = (CodeTerminal*) g_object_new (object_type, NULL);
#line 7 "../src/Widgets/Terminal.vala"
	return self;
#line 957 "Terminal.c"
}

CodeTerminal*
code_terminal_new (void)
{
#line 7 "../src/Widgets/Terminal.vala"
	return code_terminal_construct (CODE_TYPE_TERMINAL);
#line 965 "Terminal.c"
}

VteTerminal*
code_terminal_get_terminal (CodeTerminal* self)
{
	VteTerminal* result;
	VteTerminal* _tmp0_;
#line 14 "../src/Widgets/Terminal.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 14 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 14 "../src/Widgets/Terminal.vala"
	result = _tmp0_;
#line 14 "../src/Widgets/Terminal.vala"
	return result;
#line 981 "Terminal.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 14 "../src/Widgets/Terminal.vala"
	return self ? g_object_ref (self) : NULL;
#line 989 "Terminal.c"
}

static void
code_terminal_set_terminal (CodeTerminal* self,
                            VteTerminal* value)
{
	VteTerminal* old_value;
#line 14 "../src/Widgets/Terminal.vala"
	g_return_if_fail (self != NULL);
#line 14 "../src/Widgets/Terminal.vala"
	old_value = code_terminal_get_terminal (self);
#line 14 "../src/Widgets/Terminal.vala"
	if (old_value != value) {
#line 1003 "Terminal.c"
		VteTerminal* _tmp0_;
#line 14 "../src/Widgets/Terminal.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 14 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (self->priv->_terminal);
#line 14 "../src/Widgets/Terminal.vala"
		self->priv->_terminal = _tmp0_;
#line 14 "../src/Widgets/Terminal.vala"
		g_object_notify_by_pspec ((GObject *) self, code_terminal_properties[CODE_TERMINAL_TERMINAL_PROPERTY]);
#line 1013 "Terminal.c"
	}
}

static Block40Data*
block40_data_ref (Block40Data* _data40_)
{
#line 16 "../src/Widgets/Terminal.vala"
	g_atomic_int_inc (&_data40_->_ref_count_);
#line 16 "../src/Widgets/Terminal.vala"
	return _data40_;
#line 1024 "Terminal.c"
}

static void
block40_data_unref (void * _userdata_)
{
	Block40Data* _data40_;
	_data40_ = (Block40Data*) _userdata_;
#line 16 "../src/Widgets/Terminal.vala"
	if (g_atomic_int_dec_and_test (&_data40_->_ref_count_)) {
#line 1034 "Terminal.c"
		CodeTerminal* self;
#line 16 "../src/Widgets/Terminal.vala"
		self = _data40_->self;
#line 16 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (_data40_->settings);
#line 16 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (_data40_->menu);
#line 16 "../src/Widgets/Terminal.vala"
		_g_object_unref0 (self);
#line 16 "../src/Widgets/Terminal.vala"
		g_slice_free (Block40Data, _data40_);
#line 1046 "Terminal.c"
	}
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
#line 24 "../src/Widgets/Terminal.vala"
	return self ? g_settings_schema_source_ref (self) : NULL;
#line 1055 "Terminal.c"
}

static void
_code_terminal___lambda123_ (CodeTerminal* self)
{
	GApplication* _tmp0_;
#line 36 "../src/Widgets/Terminal.vala"
	_tmp0_ = g_application_get_default ();
#line 36 "../src/Widgets/Terminal.vala"
	g_action_group_activate_action ((GActionGroup*) _tmp0_, SCRATCH_MAIN_WINDOW_ACTION_PREFIX SCRATCH_MAIN_WINDOW_ACTION_TOGGLE_TERMINAL, NULL);
#line 1066 "Terminal.c"
}

static void
__code_terminal___lambda123__vte_terminal_child_exited (VteTerminal* _sender,
                                                        gint status,
                                                        gpointer self)
{
#line 35 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda123_ ((CodeTerminal*) self);
#line 1076 "Terminal.c"
}

static void
_code_terminal___lambda124_ (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
#line 41 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 41 "../src/Widgets/Terminal.vala"
	vte_terminal_copy_clipboard (_tmp0_);
#line 1087 "Terminal.c"
}

static void
__code_terminal___lambda124__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
#line 40 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda124_ ((CodeTerminal*) self);
#line 1096 "Terminal.c"
}

static void
_code_terminal___lambda125_ (CodeTerminal* self)
{
	VteTerminal* _tmp0_;
#line 46 "../src/Widgets/Terminal.vala"
	_tmp0_ = self->priv->_terminal;
#line 46 "../src/Widgets/Terminal.vala"
	vte_terminal_paste_clipboard (_tmp0_);
#line 1107 "Terminal.c"
}

static void
__code_terminal___lambda125__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
#line 45 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda125_ ((CodeTerminal*) self);
#line 1116 "Terminal.c"
}

static gboolean
_code_terminal___lambda126_ (Block40Data* _data40_,
                             GdkEventButton* event)
{
	CodeTerminal* self;
	gboolean result;
#line 54 "../src/Widgets/Terminal.vala"
	self = _data40_->self;
#line 54 "../src/Widgets/Terminal.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 55 "../src/Widgets/Terminal.vala"
	if (event->button == ((guint) 3)) {
#line 1131 "Terminal.c"
		GtkMenu* _tmp0_;
		GtkMenu* _tmp1_;
#line 56 "../src/Widgets/Terminal.vala"
		_tmp0_ = _data40_->menu;
#line 56 "../src/Widgets/Terminal.vala"
		gtk_menu_shell_select_first ((GtkMenuShell*) _tmp0_, FALSE);
#line 57 "../src/Widgets/Terminal.vala"
		_tmp1_ = _data40_->menu;
#line 57 "../src/Widgets/Terminal.vala"
		gtk_menu_popup_at_pointer (_tmp1_, (GdkEvent*) event);
#line 1142 "Terminal.c"
	}
#line 59 "../src/Widgets/Terminal.vala"
	result = FALSE;
#line 59 "../src/Widgets/Terminal.vala"
	return result;
#line 1148 "Terminal.c"
}

static gboolean
__code_terminal___lambda126__gtk_widget_button_press_event (GtkWidget* _sender,
                                                            GdkEventButton* event,
                                                            gpointer self)
{
	gboolean result;
	result = _code_terminal___lambda126_ (self, event);
#line 54 "../src/Widgets/Terminal.vala"
	return result;
#line 1160 "Terminal.c"
}

static void
_code_terminal___lambda127_ (Block40Data* _data40_)
{
	CodeTerminal* self;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 70 "../src/Widgets/Terminal.vala"
	self = _data40_->self;
#line 71 "../src/Widgets/Terminal.vala"
	_tmp0_ = _data40_->settings;
#line 71 "../src/Widgets/Terminal.vala"
	_tmp1_ = code_terminal_get_shell_location (self);
#line 71 "../src/Widgets/Terminal.vala"
	_tmp2_ = _tmp1_;
#line 71 "../src/Widgets/Terminal.vala"
	g_settings_set_string (_tmp0_, "last-opened-path", _tmp2_);
#line 71 "../src/Widgets/Terminal.vala"
	_g_free0 (_tmp2_);
#line 1182 "Terminal.c"
}

static void
__code_terminal___lambda127__gtk_widget_destroy (GtkWidget* _sender,
                                                 gpointer self)
{
#line 70 "../src/Widgets/Terminal.vala"
	_code_terminal___lambda127_ (self);
#line 1191 "Terminal.c"
}

static GObject *
code_terminal_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CodeTerminal * self;
	Block40Data* _data40_;
	VteTerminal* _tmp0_ = NULL;
	VteTerminal* _tmp1_;
	GSettingsSchemaSource* schema_source = NULL;
	GSettingsSchemaSource* _tmp2_;
	GSettingsSchemaSource* _tmp3_;
	GSettingsSchema* terminal_schema = NULL;
	GSettingsSchemaSource* _tmp4_;
	GSettingsSchema* _tmp5_;
	GSettingsSchema* _tmp6_;
	VteTerminal* _tmp10_;
	GtkMenuItem* copy = NULL;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* paste = NULL;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenu* _tmp16_;
	GtkMenuItem* _tmp17_;
	GtkMenu* _tmp18_;
	GtkMenuItem* _tmp19_;
	GtkMenu* _tmp20_;
	VteTerminal* _tmp21_;
	GSettings* _tmp22_;
	GSettings* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GtkScrolledWindow* scrolled_window = NULL;
	VteTerminal* _tmp26_;
	GtkAdjustment* _tmp27_;
	GtkScrolledWindow* _tmp28_;
	GtkScrolledWindow* _tmp29_;
	VteTerminal* _tmp30_;
	GtkScrolledWindow* _tmp31_;
#line 16 "../src/Widgets/Terminal.vala"
	parent_class = G_OBJECT_CLASS (code_terminal_parent_class);
#line 16 "../src/Widgets/Terminal.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 16 "../src/Widgets/Terminal.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CODE_TYPE_TERMINAL, CodeTerminal);
#line 16 "../src/Widgets/Terminal.vala"
	_data40_ = g_slice_new0 (Block40Data);
#line 16 "../src/Widgets/Terminal.vala"
	_data40_->_ref_count_ = 1;
#line 16 "../src/Widgets/Terminal.vala"
	_data40_->self = g_object_ref (self);
#line 17 "../src/Widgets/Terminal.vala"
	_tmp0_ = (VteTerminal*) vte_terminal_new ();
#line 17 "../src/Widgets/Terminal.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp0_, TRUE);
#line 17 "../src/Widgets/Terminal.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp0_, TRUE);
#line 17 "../src/Widgets/Terminal.vala"
	vte_terminal_set_scrollback_lines (_tmp0_, (guint) -1);
#line 17 "../src/Widgets/Terminal.vala"
	g_object_ref_sink (_tmp0_);
#line 17 "../src/Widgets/Terminal.vala"
	_tmp1_ = _tmp0_;
#line 17 "../src/Widgets/Terminal.vala"
	code_terminal_set_terminal (self, _tmp1_);
#line 17 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (_tmp1_);
#line 24 "../src/Widgets/Terminal.vala"
	_tmp2_ = g_settings_schema_source_get_default ();
#line 24 "../src/Widgets/Terminal.vala"
	_tmp3_ = _g_settings_schema_source_ref0 (_tmp2_);
#line 24 "../src/Widgets/Terminal.vala"
	schema_source = _tmp3_;
#line 25 "../src/Widgets/Terminal.vala"
	_tmp4_ = schema_source;
#line 25 "../src/Widgets/Terminal.vala"
	_tmp5_ = g_settings_schema_source_lookup (_tmp4_, CODE_TERMINAL_SETTINGS_SCHEMA, TRUE);
#line 25 "../src/Widgets/Terminal.vala"
	terminal_schema = _tmp5_;
#line 26 "../src/Widgets/Terminal.vala"
	_tmp6_ = terminal_schema;
#line 26 "../src/Widgets/Terminal.vala"
	if (_tmp6_ != NULL) {
#line 27 "../src/Widgets/Terminal.vala"
		code_terminal_update_terminal_settings (self, CODE_TERMINAL_SETTINGS_SCHEMA);
#line 1283 "Terminal.c"
	} else {
		GSettingsSchema* legacy_terminal_schema = NULL;
		GSettingsSchemaSource* _tmp7_;
		GSettingsSchema* _tmp8_;
		GSettingsSchema* _tmp9_;
#line 29 "../src/Widgets/Terminal.vala"
		_tmp7_ = schema_source;
#line 29 "../src/Widgets/Terminal.vala"
		_tmp8_ = g_settings_schema_source_lookup (_tmp7_, CODE_TERMINAL_LEGACY_SETTINGS_SCHEMA, TRUE);
#line 29 "../src/Widgets/Terminal.vala"
		legacy_terminal_schema = _tmp8_;
#line 30 "../src/Widgets/Terminal.vala"
		_tmp9_ = legacy_terminal_schema;
#line 30 "../src/Widgets/Terminal.vala"
		if (_tmp9_ != NULL) {
#line 31 "../src/Widgets/Terminal.vala"
			code_terminal_update_terminal_settings (self, CODE_TERMINAL_LEGACY_SETTINGS_SCHEMA);
#line 1301 "Terminal.c"
		}
#line 26 "../src/Widgets/Terminal.vala"
		_g_settings_schema_unref0 (legacy_terminal_schema);
#line 1305 "Terminal.c"
	}
#line 35 "../src/Widgets/Terminal.vala"
	_tmp10_ = self->priv->_terminal;
#line 35 "../src/Widgets/Terminal.vala"
	g_signal_connect_object (_tmp10_, "child-exited", (GCallback) __code_terminal___lambda123__vte_terminal_child_exited, self, 0);
#line 39 "../src/Widgets/Terminal.vala"
	_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Copy"));
#line 39 "../src/Widgets/Terminal.vala"
	g_object_ref_sink (_tmp11_);
#line 39 "../src/Widgets/Terminal.vala"
	copy = _tmp11_;
#line 40 "../src/Widgets/Terminal.vala"
	_tmp12_ = copy;
#line 40 "../src/Widgets/Terminal.vala"
	g_signal_connect_object (_tmp12_, "activate", (GCallback) __code_terminal___lambda124__gtk_menu_item_activate, self, 0);
#line 44 "../src/Widgets/Terminal.vala"
	_tmp13_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Paste"));
#line 44 "../src/Widgets/Terminal.vala"
	g_object_ref_sink (_tmp13_);
#line 44 "../src/Widgets/Terminal.vala"
	paste = _tmp13_;
#line 45 "../src/Widgets/Terminal.vala"
	_tmp14_ = paste;
#line 45 "../src/Widgets/Terminal.vala"
	g_signal_connect_object (_tmp14_, "activate", (GCallback) __code_terminal___lambda125__gtk_menu_item_activate, self, 0);
#line 49 "../src/Widgets/Terminal.vala"
	_tmp15_ = (GtkMenu*) gtk_menu_new ();
#line 49 "../src/Widgets/Terminal.vala"
	g_object_ref_sink (_tmp15_);
#line 49 "../src/Widgets/Terminal.vala"
	_data40_->menu = _tmp15_;
#line 50 "../src/Widgets/Terminal.vala"
	_tmp16_ = _data40_->menu;
#line 50 "../src/Widgets/Terminal.vala"
	_tmp17_ = copy;
#line 50 "../src/Widgets/Terminal.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp16_, _tmp17_);
#line 51 "../src/Widgets/Terminal.vala"
	_tmp18_ = _data40_->menu;
#line 51 "../src/Widgets/Terminal.vala"
	_tmp19_ = paste;
#line 51 "../src/Widgets/Terminal.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp18_, _tmp19_);
#line 52 "../src/Widgets/Terminal.vala"
	_tmp20_ = _data40_->menu;
#line 52 "../src/Widgets/Terminal.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp20_);
#line 54 "../src/Widgets/Terminal.vala"
	_tmp21_ = self->priv->_terminal;
#line 54 "../src/Widgets/Terminal.vala"
	g_signal_connect_data ((GtkWidget*) _tmp21_, "button-press-event", (GCallback) __code_terminal___lambda126__gtk_widget_button_press_event, block40_data_ref (_data40_), (GClosureNotify) block40_data_unref, 0);
#line 62 "../src/Widgets/Terminal.vala"
	_tmp22_ = g_settings_new (CONSTANTS_PROJECT_NAME ".saved-state");
#line 62 "../src/Widgets/Terminal.vala"
	_data40_->settings = _tmp22_;
#line 63 "../src/Widgets/Terminal.vala"
	_tmp23_ = _data40_->settings;
#line 63 "../src/Widgets/Terminal.vala"
	_tmp24_ = g_settings_get_string (_tmp23_, "last-opened-path");
#line 63 "../src/Widgets/Terminal.vala"
	_tmp25_ = _tmp24_;
#line 63 "../src/Widgets/Terminal.vala"
	code_terminal_spawn_shell (self, _tmp25_);
#line 63 "../src/Widgets/Terminal.vala"
	_g_free0 (_tmp25_);
#line 65 "../src/Widgets/Terminal.vala"
	_tmp26_ = self->priv->_terminal;
#line 65 "../src/Widgets/Terminal.vala"
	_tmp27_ = gtk_scrollable_get_vadjustment ((GtkScrollable*) _tmp26_);
#line 65 "../src/Widgets/Terminal.vala"
	_tmp28_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, _tmp27_);
#line 65 "../src/Widgets/Terminal.vala"
	g_object_ref_sink (_tmp28_);
#line 65 "../src/Widgets/Terminal.vala"
	scrolled_window = _tmp28_;
#line 66 "../src/Widgets/Terminal.vala"
	_tmp29_ = scrolled_window;
#line 66 "../src/Widgets/Terminal.vala"
	_tmp30_ = self->priv->_terminal;
#line 66 "../src/Widgets/Terminal.vala"
	gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp30_);
#line 68 "../src/Widgets/Terminal.vala"
	_tmp31_ = scrolled_window;
#line 68 "../src/Widgets/Terminal.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp31_);
#line 70 "../src/Widgets/Terminal.vala"
	g_signal_connect_data ((GtkWidget*) self, "destroy", (GCallback) __code_terminal___lambda127__gtk_widget_destroy, block40_data_ref (_data40_), (GClosureNotify) block40_data_unref, 0);
#line 74 "../src/Widgets/Terminal.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 16 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (scrolled_window);
#line 16 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (paste);
#line 16 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (copy);
#line 16 "../src/Widgets/Terminal.vala"
	_g_settings_schema_unref0 (terminal_schema);
#line 16 "../src/Widgets/Terminal.vala"
	_g_settings_schema_source_unref0 (schema_source);
#line 16 "../src/Widgets/Terminal.vala"
	block40_data_unref (_data40_);
#line 16 "../src/Widgets/Terminal.vala"
	_data40_ = NULL;
#line 16 "../src/Widgets/Terminal.vala"
	return obj;
#line 1411 "Terminal.c"
}

static void
code_terminal_class_init (CodeTerminalClass * klass,
                          gpointer klass_data)
{
#line 7 "../src/Widgets/Terminal.vala"
	code_terminal_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/Widgets/Terminal.vala"
	g_type_class_adjust_private_offset (klass, &CodeTerminal_private_offset);
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_code_terminal_get_property;
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_code_terminal_set_property;
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->constructor = code_terminal_constructor;
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (klass)->finalize = code_terminal_finalize;
#line 7 "../src/Widgets/Terminal.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CODE_TERMINAL_TERMINAL_PROPERTY, code_terminal_properties[CODE_TERMINAL_TERMINAL_PROPERTY] = g_param_spec_object ("terminal", "terminal", "terminal", vte_terminal_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1432 "Terminal.c"
}

static void
code_terminal_instance_init (CodeTerminal * self,
                             gpointer klass)
{
#line 7 "../src/Widgets/Terminal.vala"
	self->priv = code_terminal_get_instance_private (self);
#line 1441 "Terminal.c"
}

static void
code_terminal_finalize (GObject * obj)
{
	CodeTerminal * self;
#line 7 "../src/Widgets/Terminal.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CODE_TYPE_TERMINAL, CodeTerminal);
#line 14 "../src/Widgets/Terminal.vala"
	_g_object_unref0 (self->priv->_terminal);
#line 7 "../src/Widgets/Terminal.vala"
	G_OBJECT_CLASS (code_terminal_parent_class)->finalize (obj);
#line 1454 "Terminal.c"
}

static GType
code_terminal_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CodeTerminalClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) code_terminal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CodeTerminal), 0, (GInstanceInitFunc) code_terminal_instance_init, NULL };
	GType code_terminal_type_id;
	code_terminal_type_id = g_type_register_static (gtk_box_get_type (), "CodeTerminal", &g_define_type_info, 0);
	CodeTerminal_private_offset = g_type_add_instance_private (code_terminal_type_id, sizeof (CodeTerminalPrivate));
	return code_terminal_type_id;
}

GType
code_terminal_get_type (void)
{
	static volatile gsize code_terminal_type_id__once = 0;
	if (g_once_init_enter (&code_terminal_type_id__once)) {
		GType code_terminal_type_id;
		code_terminal_type_id = code_terminal_get_type_once ();
		g_once_init_leave (&code_terminal_type_id__once, code_terminal_type_id);
	}
	return code_terminal_type_id__once;
}

static void
_vala_code_terminal_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	CodeTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CODE_TYPE_TERMINAL, CodeTerminal);
#line 7 "../src/Widgets/Terminal.vala"
	switch (property_id) {
#line 7 "../src/Widgets/Terminal.vala"
		case CODE_TERMINAL_TERMINAL_PROPERTY:
#line 7 "../src/Widgets/Terminal.vala"
		g_value_set_object (value, code_terminal_get_terminal (self));
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 1495 "Terminal.c"
		default:
#line 7 "../src/Widgets/Terminal.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 1501 "Terminal.c"
	}
}

static void
_vala_code_terminal_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	CodeTerminal * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CODE_TYPE_TERMINAL, CodeTerminal);
#line 7 "../src/Widgets/Terminal.vala"
	switch (property_id) {
#line 7 "../src/Widgets/Terminal.vala"
		case CODE_TERMINAL_TERMINAL_PROPERTY:
#line 7 "../src/Widgets/Terminal.vala"
		code_terminal_set_terminal (self, g_value_get_object (value));
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 1521 "Terminal.c"
		default:
#line 7 "../src/Widgets/Terminal.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Widgets/Terminal.vala"
		break;
#line 1527 "Terminal.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 181 "../src/Services/TemplateManager.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1538 "Terminal.c"
		gssize i;
#line 181 "../src/Services/TemplateManager.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 181 "../src/Services/TemplateManager.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 181 "../src/Services/TemplateManager.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1546 "Terminal.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 181 "../src/Services/TemplateManager.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 181 "../src/Services/TemplateManager.vala"
	g_free (array);
#line 1561 "Terminal.c"
}

